﻿Public Class Form1
    ' Define appointment types.
    Private Enum AppointmentType
        None
        Work
        Home
        Other
    End Enum

    ' Define an appointment structure.
    Private Structure Appointment
        Public Time As Date
        Public Attendees As String
        Public Type As AppointmentType
        Public Topic As String
        Public Notes As String
    End Structure

    ' Make a Dictionary to hold appointments.
    Private Appointments As Dictionary(Of DateTime, Appointment) =
        New Dictionary(Of DateTime, Appointment)()

    ' Make sure the ComboBox starts with an item selected
    ' and initialize thue DateTimePicker.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Make sure the ComboBox starts with an item selected.
        cboAppointmentType.SelectedIndex = 0

        ' Initialize the DateTimePicker.
        dtpAppointment.Value = New DateTime(
            DateTime.Now.Year,
            DateTime.Now.Month,
            DateTime.Now.Day,
            DateTime.Now.Hour,
            DateTime.Now.Minute,
            DateTime.Now.Second)
    End Sub

    ' Add a new appointment.
    Private Sub btnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAdd.Click
        ' Fill in a new Appointment structure.
        Dim newAppointment As Appointment
        newAppointment.Time = dtpAppointment.Value
        newAppointment.Attendees = txtAttendees.Text
        newAppointment.Type =
            CType(cboAppointmentType.SelectedIndex, AppointmentType)
        newAppointment.Topic = txtTopic.Text
        newAppointment.Notes = txtNotes.Text

        ' Add the time and appointment to the dictionary.
        Appointments.Add(newAppointment.Time, newAppointment)

        ' Get ready for the next one.
        txtAttendees.Clear()
        cboAppointmentType.SelectedIndex = 0
        txtTopic.Clear()
        txtNotes.Clear()

        dtpAppointment.Focus()
    End Sub

    ' Look up an Appointment.
    Private Sub btnFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFind.Click
        ' Get the Appointment.
        Dim selectedAppointment As Appointment =
            Appointments(dtpAppointment.Value)

        ' Display the Appointment's values.
        txtAttendees.Text = selectedAppointment.Attendees
        cboAppointmentType.SelectedIndex = CInt(selectedAppointment.Type)
        txtTopic.Text = selectedAppointment.Topic
        txtNotes.Text = selectedAppointment.Notes
    End Sub

    ' Delete an entry.
    Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        Appointments.Remove(dtpAppointment.Value)

        ' Get ready for the next one.
        txtAttendees.Clear()
        cboAppointmentType.SelectedIndex = 0
        txtTopic.Clear()
        txtNotes.Clear()

        dtpAppointment.Focus()
    End Sub
End Class
