﻿Public Class Form1
    ' *************
    ' * File menu *
    ' *************
    Private Sub mnuFileNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileNew.Click, btnNew.Click
        ' See if it's okay to continue.
        If IsDataSafe() Then
            ' Make the new document.
            rchDocument.Clear()

            ' There are no unsaved changes now.
            rchDocument.Modified = False
        End If
    End Sub

    Private Sub mnuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileOpen.Click, btnOpen.Click
        ' See if it's okay to continue.
        If IsDataSafe() Then
            If (ofdDocument.ShowDialog() = DialogResult.OK) Then
                ' Open the file.
                rchDocument.LoadFile(ofdDocument.FileName, RichTextBoxStreamType.RichText)

                ' There are no unsaved changes now.
                rchDocument.Modified = False
            End If
        End If
    End Sub

    Private Sub mnuFileSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileSave.Click, btnSave.Click
        If (sfdDocument.ShowDialog() = DialogResult.OK) Then
            rchDocument.SaveFile(sfdDocument.FileName, RichTextBoxStreamType.RichText)
            rchDocument.Modified = False
        End If
    End Sub

    Private Sub mnuFileSaveAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileSaveAs.Click
        MessageBox.Show("Save As")
    End Sub

    Private Sub mnuFilePrintPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFilePrintPreview.Click, btnPreview.Click
        MessageBox.Show("Print Preview")
    End Sub

    Private Sub mnuFilePrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFilePrint.Click, btnPrint.Click
        MessageBox.Show("Print")
    End Sub

    ' Close the form.
    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        Me.Close()
    End Sub

    ' *************
    ' * Edit menu *
    ' *************
    Private Sub mnuEditUndo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditUndo.Click, btnUndo.Click
        rchDocument.Undo()
    End Sub

    Private Sub mnuEditRedo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditRedo.Click, btnRedo.Click
        rchDocument.Redo()
    End Sub

    Private Sub mnuEditCopy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditCopy.Click, btnCopy.Click
        rchDocument.Copy()
    End Sub

    Private Sub mnuEditCut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditCut.Click, btnCut.Click
        rchDocument.Cut()
    End Sub

    Private Sub mnuEditPaste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditPaste.Click, btnPaste.Click
        rchDocument.Paste()
    End Sub

    Private Sub mnuEditDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditDelete.Click, deleteButton.Click
        rchDocument.SelectedText = ""
    End Sub

    Private Sub mnuEditSelectAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditSelectAll.Click
        rchDocument.SelectAll()
    End Sub

    ' ***************
    ' * Format menu *
    ' ***************
    Private Sub mnuFormatAlignLeft_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFormatAlignLeft.Click, ctxAlignLeft.Click, btnAlignLeft.Click
        mnuFormatAlignLeft.Checked = True
        mnuFormatAlignRight.Checked = False
        mnuFormatAlignCenter.Checked = False
        ctxAlignLeft.Checked = True
        ctxAlignRight.Checked = False
        ctxAlignCenter.Checked = False
        btnAlignLeft.Checked = True
        btnAlignRight.Checked = False
        btnAlignCenter.Checked = False
        mnuFormatAlign.Image = mnuFormatAlignLeft.Image

        rchDocument.SelectionAlignment = HorizontalAlignment.Left
    End Sub

    Private Sub mnuFormatAlignRight_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFormatAlignRight.Click, ctxAlignRight.Click, btnAlignRight.Click
        mnuFormatAlignLeft.Checked = False
        mnuFormatAlignRight.Checked = True
        mnuFormatAlignCenter.Checked = False
        ctxAlignLeft.Checked = False
        ctxAlignRight.Checked = True
        ctxAlignCenter.Checked = False
        btnAlignLeft.Checked = False
        btnAlignRight.Checked = True
        btnAlignCenter.Checked = False
        mnuFormatAlign.Image = mnuFormatAlignRight.Image

        rchDocument.SelectionAlignment = HorizontalAlignment.Right
    End Sub

    Private Sub mnuFormatAlignCenter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFormatAlignCenter.Click, ctxAlignCenter.Click, btnAlignCenter.Click
        mnuFormatAlignLeft.Checked = False
        mnuFormatAlignRight.Checked = False
        mnuFormatAlignCenter.Checked = True
        ctxAlignLeft.Checked = False
        ctxAlignRight.Checked = False
        ctxAlignCenter.Checked = True
        btnAlignLeft.Checked = False
        btnAlignRight.Checked = False
        btnAlignCenter.Checked = True
        mnuFormatAlign.Image = mnuFormatAlignCenter.Image

        rchDocument.SelectionAlignment = HorizontalAlignment.Center
    End Sub

    Private Sub mnuFormatTextColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFormatTextColor.Click, ctxTextColor.Click
        cdSelectedText.Color = rchDocument.SelectionColor
        If (cdSelectedText.ShowDialog() = DialogResult.OK) Then
            rchDocument.SelectionColor = cdSelectedText.Color
        End If
    End Sub

    Private Sub mnuFormatBackgroundColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFormatBackgroundColor.Click, ctxBackgroundColor.Click
        cdSelectedText.Color = rchDocument.SelectionBackColor
        If (cdSelectedText.ShowDialog() = DialogResult.OK) Then
            rchDocument.SelectionBackColor = cdSelectedText.Color
        End If
    End Sub

    Private Sub mnuFormatBullet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFormatBullet.Click
        ctxBullet.Checked = mnuFormatBullet.Checked
        btnBullet.Checked = mnuFormatBullet.Checked

        rchDocument.SelectionBullet = btnBullet.Checked
    End Sub
    Private Sub ctxBullet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ctxBullet.Click
        mnuFormatBullet.Checked = ctxBullet.Checked
        btnBullet.Checked = ctxBullet.Checked

        rchDocument.SelectionBullet = btnBullet.Checked
    End Sub
    Private Sub btnBullet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBullet.Click
        mnuFormatBullet.Checked = btnBullet.Checked
        ctxBullet.Checked = btnBullet.Checked

        rchDocument.SelectionBullet = btnBullet.Checked
    End Sub

    Private Sub mnuFormatOffsetNormal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFormatOffsetNormal.Click, ctxOffsetNormal.Click, btnOffsetNormal.Click
        mnuFormatOffsetNormal.Checked = True
        mnuFormatOffsetSuperscript.Checked = False
        mnuFormatOffsetSubscript.Checked = False
        ctxOffsetNormal.Checked = True
        ctxOffsetSuperscript.Checked = False
        ctxOffsetSubscript.Checked = False
        btnOffsetNormal.Checked = True
        btnOffsetSuperscript.Checked = False
        btnOffsetSubscript.Checked = False
        btnOffset.Image = btnOffsetNormal.Image
        mnuFormatOffset.Image = mnuFormatOffsetNormal.Image

        rchDocument.SelectionCharOffset = 0
    End Sub

    Private Sub mnuFormatOffsetSuperscript_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFormatOffsetSuperscript.Click, ctxOffsetSuperscript.Click, btnOffsetSuperscript.Click
        mnuFormatOffsetNormal.Checked = False
        mnuFormatOffsetSuperscript.Checked = True
        mnuFormatOffsetSubscript.Checked = False
        ctxOffsetNormal.Checked = False
        ctxOffsetSuperscript.Checked = True
        ctxOffsetSubscript.Checked = False
        btnOffsetNormal.Checked = False
        btnOffsetSuperscript.Checked = True
        btnOffsetSubscript.Checked = False
        btnOffset.Image = btnOffsetSuperscript.Image
        mnuFormatOffset.Image = mnuFormatOffsetSuperscript.Image

        rchDocument.SelectionCharOffset = 5
    End Sub

    Private Sub mnuFormatOffsetSubscript_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFormatOffsetSubscript.Click, ctxOffsetSubscript.Click, btnOffsetSubscript.Click
        mnuFormatOffsetNormal.Checked = False
        mnuFormatOffsetSuperscript.Checked = False
        mnuFormatOffsetSubscript.Checked = True
        ctxOffsetNormal.Checked = False
        ctxOffsetSuperscript.Checked = False
        ctxOffsetSubscript.Checked = True
        btnOffsetNormal.Checked = False
        btnOffsetSuperscript.Checked = False
        btnOffsetSubscript.Checked = True
        btnOffset.Image = btnOffsetSubscript.Image
        mnuFormatOffset.Image = mnuFormatOffsetSubscript.Image

        rchDocument.SelectionCharOffset = -5
    End Sub

    Private Sub mnuFormatFont_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFormatFont.Click, ctxFont.Click, btnFont.Click
        fdSelectedText.Font = rchDocument.Font
        If (fdSelectedText.ShowDialog() = DialogResult.OK) Then
            rchDocument.SelectionFont = fdSelectedText.Font
        End If
    End Sub

    Private Sub mnuFormatIndentNone_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFormatIndentNone.Click, ctxIndentNone.Click, btnIndentNone.Click
        mnuFormatIndentNone.Checked = True
        mnuFormatIndentHanging.Checked = False
        mnuFormatIndentLeft.Checked = False
        mnuFormatIndentRight.Checked = False
        mnuFormatIndentBoth.Checked = False
        ctxIndentNone.Checked = True
        ctxIndentHanging.Checked = False
        ctxIndentLeft.Checked = False
        ctxIndentRight.Checked = False
        ctxIndentBoth.Checked = False
        btnIndentNone.Checked = True
        btnIndentHanging.Checked = False
        btnIndentLeft.Checked = False
        btnIndentRight.Checked = False
        btnIndentBoth.Checked = False
        btnIndent.Image = btnIndentNone.Image
        mnuFormatIndent.Image = mnuFormatIndentNone.Image

        rchDocument.SelectionIndent = 0
        rchDocument.SelectionRightIndent = 0
        rchDocument.SelectionHangingIndent = 0
    End Sub

    Private Sub mnuFormatIndentHanging_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFormatIndentHanging.Click, ctxIndentHanging.Click, btnIndentHanging.Click
        mnuFormatIndentNone.Checked = False
        mnuFormatIndentHanging.Checked = True
        mnuFormatIndentLeft.Checked = False
        mnuFormatIndentRight.Checked = False
        mnuFormatIndentBoth.Checked = False
        ctxIndentNone.Checked = False
        ctxIndentHanging.Checked = True
        ctxIndentLeft.Checked = False
        ctxIndentRight.Checked = False
        ctxIndentBoth.Checked = False
        btnIndentNone.Checked = False
        btnIndentHanging.Checked = True
        btnIndentLeft.Checked = False
        btnIndentRight.Checked = False
        btnIndentBoth.Checked = False
        btnIndent.Image = btnIndentHanging.Image
        mnuFormatIndent.Image = mnuFormatIndentHanging.Image

        rchDocument.SelectionIndent = 0
        rchDocument.SelectionRightIndent = 0
        rchDocument.SelectionHangingIndent = 20
    End Sub

    Private Sub mnuFormatIndentLeft_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFormatIndentLeft.Click, ctxIndentLeft.Click, btnIndentLeft.Click
        mnuFormatIndentNone.Checked = False
        mnuFormatIndentHanging.Checked = False
        mnuFormatIndentLeft.Checked = True
        mnuFormatIndentRight.Checked = False
        mnuFormatIndentBoth.Checked = False
        ctxIndentNone.Checked = False
        ctxIndentHanging.Checked = False
        ctxIndentLeft.Checked = True
        ctxIndentRight.Checked = False
        ctxIndentBoth.Checked = False
        btnIndentNone.Checked = False
        btnIndentHanging.Checked = False
        btnIndentLeft.Checked = True
        btnIndentRight.Checked = False
        btnIndentBoth.Checked = False
        btnIndent.Image = btnIndentLeft.Image
        mnuFormatIndent.Image = mnuFormatIndentLeft.Image

        rchDocument.SelectionIndent = 20
        rchDocument.SelectionRightIndent = 0
        rchDocument.SelectionHangingIndent = 0
    End Sub

    Private Sub mnuFormatIndentRight_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFormatIndentRight.Click, ctxIndentRight.Click, btnIndentRight.Click
        mnuFormatIndentNone.Checked = False
        mnuFormatIndentHanging.Checked = False
        mnuFormatIndentLeft.Checked = False
        mnuFormatIndentRight.Checked = True
        mnuFormatIndentBoth.Checked = False
        ctxIndentNone.Checked = False
        ctxIndentHanging.Checked = False
        ctxIndentLeft.Checked = False
        ctxIndentRight.Checked = True
        ctxIndentBoth.Checked = False
        btnIndentNone.Checked = False
        btnIndentHanging.Checked = False
        btnIndentLeft.Checked = False
        btnIndentRight.Checked = True
        btnIndentBoth.Checked = False
        btnIndent.Image = btnIndentRight.Image
        mnuFormatIndent.Image = mnuFormatIndentRight.Image

        rchDocument.SelectionIndent = 0
        rchDocument.SelectionRightIndent = 20
        rchDocument.SelectionHangingIndent = 0
    End Sub

    Private Sub mnuFormatIndentBoth_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFormatIndentBoth.Click, ctxIndentBoth.Click, btnIndentBoth.Click
        mnuFormatIndentNone.Checked = False
        mnuFormatIndentHanging.Checked = False
        mnuFormatIndentLeft.Checked = False
        mnuFormatIndentRight.Checked = False
        mnuFormatIndentBoth.Checked = True
        ctxIndentNone.Checked = False
        ctxIndentHanging.Checked = False
        ctxIndentLeft.Checked = False
        ctxIndentRight.Checked = False
        ctxIndentBoth.Checked = True
        btnIndentNone.Checked = False
        btnIndentHanging.Checked = False
        btnIndentLeft.Checked = False
        btnIndentRight.Checked = False
        btnIndentBoth.Checked = True
        btnIndent.Image = btnIndentBoth.Image
        mnuFormatIndent.Image = mnuFormatIndentBoth.Image

        rchDocument.SelectionIndent = 20
        rchDocument.SelectionRightIndent = 20
        rchDocument.SelectionHangingIndent = 0
    End Sub

    ' **************
    ' * Text Color *
    ' **************
    Private Sub btnTextColor_ButtonClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTextColor.ButtonClick
        rchDocument.SelectionColor = btnTextColor.ForeColor
    End Sub

    Private Sub btnTextColorBlack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTextColorBlack.Click
        btnTextColor.Image = btnTextColorBlack.Image
        btnTextColor.ForeColor = Color.Black

        rchDocument.SelectionColor = btnTextColor.ForeColor
    End Sub

    Private Sub btnTextColorWhite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTextColorWhite.Click
        btnTextColor.Image = btnTextColorWhite.Image
        btnTextColor.ForeColor = Color.White

        rchDocument.SelectionColor = btnTextColor.ForeColor
    End Sub

    Private Sub btnTextColorRed_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTextColorRed.Click
        btnTextColor.Image = btnTextColorRed.Image
        btnTextColor.ForeColor = Color.Red

        rchDocument.SelectionColor = btnTextColor.ForeColor
    End Sub

    Private Sub btnTextColorGreen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTextColorGreen.Click
        ctxTextColor.Image = btnTextColorGreen.Image
        btnTextColor.ForeColor = Color.Green

        rchDocument.SelectionColor = btnTextColor.ForeColor
    End Sub

    Private Sub btnTextColorBlue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTextColorBlue.Click
        btnTextColor.Image = btnTextColorBlue.Image
        btnTextColor.ForeColor = Color.Blue

        rchDocument.SelectionColor = btnTextColor.ForeColor
    End Sub

    ' ********************
    ' * Background Color *
    ' ********************
    Private Sub btnBackgroundColor_ButtonClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBackgroundColor.ButtonClick
        rchDocument.SelectionBackColor = btnBackgroundColor.BackColor
    End Sub

    Private Sub btnBackgroundColorBlack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBackgroundColorBlack.Click
        mnuFormatBackgroundColor.Image = btnBackgroundColorBlack.Image
        ctxBackgroundColor.Image = btnBackgroundColorBlack.Image
        btnBackgroundColor.Image = btnBackgroundColorBlack.Image
        btnBackgroundColor.BackColor = Color.Black

        rchDocument.SelectionBackColor = btnBackgroundColor.BackColor
    End Sub

    Private Sub btnBackgroundColorWhite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBackgroundColorWhite.Click
        mnuFormatBackgroundColor.Image = btnBackgroundColorWhite.Image
        ctxBackgroundColor.Image = btnBackgroundColorWhite.Image
        btnBackgroundColor.Image = btnBackgroundColorWhite.Image
        btnBackgroundColor.BackColor = Color.White

        rchDocument.SelectionBackColor = btnBackgroundColor.BackColor
    End Sub

    Private Sub btnBackgroundColorPink_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBackgroundColorPink.Click
        mnuFormatBackgroundColor.Image = btnBackgroundColorPink.Image
        ctxBackgroundColor.Image = btnBackgroundColorPink.Image
        btnBackgroundColor.Image = btnBackgroundColorPink.Image
        btnBackgroundColor.BackColor = Color.Pink

        rchDocument.SelectionBackColor = btnBackgroundColor.BackColor
    End Sub

    Private Sub btnBackgroundColorGreen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBackgroundColorGreen.Click
        mnuFormatBackgroundColor.Image = btnBackgroundColorGreen.Image
        ctxBackgroundColor.Image = btnBackgroundColorGreen.Image
        btnBackgroundColor.Image = btnBackgroundColorGreen.Image
        btnBackgroundColor.BackColor = Color.LightGreen

        rchDocument.SelectionBackColor = btnBackgroundColor.BackColor
    End Sub

    Private Sub btnBackgroundColorBlue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBackgroundColorBlue.Click
        mnuFormatBackgroundColor.Image = btnBackgroundColorBlue.Image
        ctxBackgroundColor.Image = btnBackgroundColorBlue.Image
        btnBackgroundColor.Image = btnBackgroundColorBlue.Image
        btnBackgroundColor.BackColor = Color.LightBlue

        rchDocument.SelectionBackColor = btnBackgroundColor.BackColor
    End Sub

    Private Sub btnBackgroundColorYellow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBackgroundColorYellow.Click
        mnuFormatBackgroundColor.Image = btnBackgroundColorYellow.Image
        ctxBackgroundColor.Image = btnBackgroundColorYellow.Image
        btnBackgroundColor.Image = btnBackgroundColorYellow.Image
        btnBackgroundColor.BackColor = Color.Yellow

        rchDocument.SelectionBackColor = btnBackgroundColor.BackColor
    End Sub

    ' Protect unsaved changes.
    Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        ' If it's not safe, cancel the close.
        e.Cancel = Not IsDataSafe()
    End Sub

    ' Return True if it is safe to discard the current document.
    Private Function IsDataSafe() As Boolean
        ' If there are no unsaved changes, then the data is safe.
        If Not rchDocument.Modified Then Return True

        ' See if the user wants to save the changes.
        Dim result As DialogResult =
            MessageBox.Show("Do you want to save the changes?",
                "Save Changes?", MessageBoxButtons.YesNoCancel)

        Select Case result
            Case DialogResult.Yes
                ' Save the changes here.
                If (sfdDocument.ShowDialog() = DialogResult.OK) Then
                    rchDocument.SaveFile(sfdDocument.FileName, RichTextBoxStreamType.RichText)

                    ' We saved so thue data is safe.
                    Return True
                Else
                    ' We didn't save so the data is not safe.
                    Return False
                End If

            Case DialogResult.No
                ' The user doesn't want to save the changes
                ' so it's safe to discard them.
                Return True

            Case DialogResult.Cancel
                ' The user wants to cancel. Don't discard the changes.
                Return False
        End Select

        ' This should never happen but Visual Studio wants to know
        ' that the function will definitely return something.
        Return True
    End Function
End Class
