﻿Public Class Form1
    ' Calculate LCM(a, b).
    Private Sub btnCalculate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCalculate.Click
        Try
            ' Get the input values.
            Dim a As Long = Long.Parse(txtA.Text)
            Dim b As Long = Long.Parse(txtB.Text)

            ' Calculate the LCM.
            Dim result As Long = Lcm(a, b)

            ' Display the result.
            txtResult.Text = result.ToString()
        Catch ex As Exception
            MessageBox.Show("Error calculating the LCM" & vbCrLf & vbCrLf & ex.Message)
            txtResult.Clear()
        End Try
    End Sub

    ' Calculate GCD(a, b).
    Private Function Gcd(ByVal a As Long, ByVal b As Long) As Long
        ' Validate inputs.
        If (a <= 0) Then Throw New ArgumentOutOfRangeException(
            "a", "GCD parameters must be greater than 0")
        If (b <= 0) Then Throw New ArgumentOutOfRangeException(
            "b", "GCD parameters must be greater than 0")

        Dim remainder As Long
        Do
            remainder = a Mod b
            If (remainder <> 0) Then
                a = b
                b = remainder
            End If
        Loop While (remainder > 0)

        Return b
    End Function

    ' Calculate LCM(a, b).
    Private Function Lcm(ByVal a As Long, ByVal b As Long) As Long
        ' Validate inputs.
        If (a <= 0) Then Throw New ArgumentOutOfRangeException(
            "a", "LCM parameters must be greater than 0")
        If (b <= 0) Then Throw New ArgumentOutOfRangeException(
            "b", "LCM parameters must be greater than 0")

        Return a * (b \ Gcd(a, b))
    End Function
End Class
