﻿Public Class Form1
    ' Calculate the Fibonacci number.
    Private Sub btnCalculate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCalculate.Click
        Try
            ' Calculate and display the Fibonacci number.
            Dim n As Long = Long.Parse(txtNumber.Text)
            Dim result As Long = Fibonacci(n)
            txtResult.Text = result.ToString("#,##0")
        Catch ex As Exception
            MessageBox.Show("Error calculating the Fibonacci number." & vbCrLf & vbCrLf & ex.Message)
            txtResult.Clear()
        End Try
    End Sub

    ' Calculate the n-th Fibonacci number.
    Private Function Fibonacci(ByVal n As Long) As Long
        ' Validate inputs.
        If (n < 0) Then Throw New ArgumentOutOfRangeException(
            "n", "Fibonacci parameters must be at least 0.")

        ' Initialize the base cases.
        Dim fibo1 As Long = 0   ' Initially Fibonacci(0).
        Dim fibo2 As Long = 1   ' Initially Fibonacci(1).
        Dim fiboN As Long = 0   ' Initially Fibonacci(0).

        ' Calculate the result.
        For i As Long = 0 To n - 1
            ' Calculate fiboN from fibo1 and fibo2.
            fiboN = fibo1 + fibo2

            ' Update fibo1 and fibo2 for the next loop.
            fibo2 = fibo1
            fibo1 = fiboN
        Next i

        ' Return the result.
        Return fiboN
    End Function
End Class
