﻿Public Class Form1
    Private Sub btnCalculate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCalculate.Click
        Try
            Dim miles As Double = Double.Parse(txtMiles.Text)
            Dim gallons As Double = Double.Parse(txtGallons.Text)
            Dim mpg As Double = MilesPerGallon(miles, gallons)
            txtResult.Text = String.Format("{0:0.00} miles per gallon", mpg)
        Catch ex As Exception
            txtResult.Clear()
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    ' Calculate miles per gallon.
    Private Function MilesPerGallon(ByVal miles As Double, ByVal gallons As Double) As Double
        ' Sanity checks.
        If (miles <= 0) Then
            Throw New ArgumentOutOfRangeException("miles",
                "MilesPerGallon: miles must be greater than 0.")
        End If
        If (gallons <= 0) Then
            Throw New ArgumentOutOfRangeException("gallons",
                "MilesPerGallon: gallons must be greater than 0.")
        End If
        Debug.Assert(miles <= 1100, "Miles is too big.")
        Debug.Assert(gallons <= 30, "Gallons is too big.")

        ' Calculate the result.
        Dim result As Double = miles / gallons

        ' Check the result for reasonableness
        Debug.Assert(result > 1, "Result too small")
        Debug.Assert(result < 60, "Result too large")

        ' Return the result.
        Return result
    End Function
End Class
