﻿Public Class Person
    ' Auto-implemented properties.
    Public Property Street As String
    Public Property City As String
    Public Property State As String

    ' FirstName property.
    Private _FirstName As String = ""
    Public Property FirstName As String
        Get
            Return _FirstName
        End Get
        Set(ByVal value As String)
            If (value Is Nothing) Then
                Throw New ArgumentOutOfRangeException("FirstName",
                    "Person.FirstName cannot be null.")
            End If
            If (value.Length < 1) Then
                Throw New ArgumentOutOfRangeException("FirstName",
                    "Person.FirstName cannot be blank.")
            End If

            ' Validations passed. Save the new value.
            _FirstName = value
        End Set
    End Property

    ' LastName property.
    Private _LastName As String = ""
    Public Property LastName As String
        Get
            Return _LastName
        End Get
        Set(ByVal value As String)
            If (value Is Nothing) Then
                Throw New ArgumentOutOfRangeException("LastName",
                    "Person.LastName cannot be null.")
            End If
            If (value.Length < 1) Then
                Throw New ArgumentOutOfRangeException("LastName",
                    "Person.LastName cannot be blank.")
            End If

            ' Validations passed. Save the new value.
            _LastName = value
        End Set
    End Property

    ' Zip property.
    Private _Zip As String = ""
    Public Property Zip As String
        Get
            Return _Zip
        End Get
        Set(ByVal value As String)
            If (value Is Nothing) Then
                Throw New ArgumentOutOfRangeException("Zip",
                    "Person.Zip cannot be null.")
            End If
            If (value.Length < 1) Then
                Throw New ArgumentOutOfRangeException("Zip",
                    "Person.Zip cannot be blank.")
            End If

            ' Validate the format.
            If Not (value Like "#####") Then
                Throw New FormatException("Person.Zip has an invalid format.")
            End If

            ' Validations passed. Save the new value.
            _Zip = value
        End Set
    End Property
End Class
