﻿Public Class ArrayMethods
    ' Randomize the items in an array.
    Public Shared Function Randomize(Of T)(ByVal items() As T) As T()
        ' Make a Random object to use to pick random items.
        Dim rand As Random = New Random()

        ' Make a copy of the array so we don't mess up the original.
        Dim randomizedItems() As T = DirectCast(items.Clone(), T())

        ' For each spot in the array, pick
        ' a random item to swap into that spot.
        For i As Integer = 0 To items.Length - 2
            ' Pick a random item j between i and the last item.
            Dim j As Integer = rand.Next(i, items.Length)

            ' Swap item j into position i.
            Dim temp As T = randomizedItems(i)
            randomizedItems(i) = randomizedItems(j)
            randomizedItems(j) = temp
        Next i

        ' Return the randomized array.
        Return randomizedItems
    End Function

    ' Alternate the items in the array.
    Public Shared Function Alternate(Of T)(ByVal values As List(Of T)) As List(Of T)
        ' Make a new list to hold the results.
        Dim alternatedItems As List(Of T) = New List(Of T)

        For i As Integer = 0 To values.Count \ 2 - 1
            alternatedItems.Add(values(i))
            alternatedItems.Add(values(values.Count - 1 - i))
        Next i
        If values.Count Mod 2 = 1 Then
            alternatedItems.Add(values(values.Count \ 2))
        End If

        Return alternatedItems
    End Function
End Class
