﻿Public Class Form1
    ' Display a print preview.
    Private Sub btnPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPreview.Click
        ppdTable.ShowDialog()
    End Sub

    ' Print to the default printer.
    Private Sub btnPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint.Click
        pdocTable.Print()
    End Sub

    ' Print the table.
    Private Sub pdocTable_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles pdocTable.PrintPage
        ' Make some data.
        Dim students() As Student =
        {
            New Student() With {.FirstName = "Ann", .LastName = "Archer",
                .TestScores = {91, 92, 93, 94}},
            New Student() With {.FirstName = "Bob", .LastName = "Blarth",
                .TestScores = {81, 82, 83, 84}},
            New Student() With {.FirstName = "Cyd", .LastName = "Carter",
                .TestScores = {71, 72, 73, 74}},
            New Student() With {.FirstName = "Dan", .LastName = "Deever",
                .TestScores = {61, 62, 63, 64}}
        }

        ' Get the coordinates for the first row and the columns.
        Dim y As Integer = e.MarginBounds.Top
        Dim x0 As Integer = e.MarginBounds.Left
        Dim x1 As Integer = x0 + 200
        Dim x2 As Integer = x1 + 100
        Dim x3 As Integer = x2 + 100
        Dim x4 As Integer = x3 + 100
        Dim x5 As Integer = x4 + 100

        ' Make a font to use.
        Using the_font As New Font("Times New Roman", 20)
            ' Draw column headers.
            e.Graphics.DrawString("Name", the_font, Brushes.Black, x0, y)
            e.Graphics.DrawString("Test 1", the_font, Brushes.Black, x1, y)
            e.Graphics.DrawString("Test 2", the_font, Brushes.Black, x2, y)
            e.Graphics.DrawString("Test 3", the_font, Brushes.Black, x3, y)
            e.Graphics.DrawString("Test 4", the_font, Brushes.Black, x4, y)

            ' Move Y down for the first row.
            y += 30

            ' Loop through the Students displaying their data.
            For Each a_student As Student In students
                ' Display the Student's values.
                e.Graphics.DrawString(a_student.FirstName & " " &
                    a_student.LastName, the_font, Brushes.Black, x0, y)
                e.Graphics.DrawString(a_student.TestScores(0).ToString(),
                    the_font, Brushes.Black, x1, y)
                e.Graphics.DrawString(a_student.TestScores(1).ToString(),
                    the_font, Brushes.Black, x2, y)
                e.Graphics.DrawString(a_student.TestScores(2).ToString(),
                    the_font, Brushes.Black, x3, y)
                e.Graphics.DrawString(a_student.TestScores(3).ToString(),
                    the_font, Brushes.Black, x4, y)

                ' Draw a line over the row.
                e.Graphics.DrawLine(Pens.Black, x0, y, x5, y)

                ' Move Y down for the next row.
                y += 30
            Next a_student
        End Using

        ' Draw lines between columns.
        e.Graphics.DrawLine(Pens.Black, x1, e.MarginBounds.Top, x1, y)
        e.Graphics.DrawLine(Pens.Black, x2, e.MarginBounds.Top, x2, y)
        e.Graphics.DrawLine(Pens.Black, x3, e.MarginBounds.Top, x3, y)
        e.Graphics.DrawLine(Pens.Black, x4, e.MarginBounds.Top, x4, y)

        ' Draw a box around it all.
        e.Graphics.DrawRectangle(Pens.Black,
            x0, e.MarginBounds.Top,
            x4 - x0 + 100,
            y - e.MarginBounds.Top)

        ' We're only printing one page.
        e.HasMorePages = False
    End Sub
End Class
