Public Class Form1
    ' The numeric code for Ctrl.
    Private Const KeyCtrl As Integer = 8

    ' A drag entered. See if text is available.
    Private Sub lblDrop_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lblDrop.DragEnter
        ' Allow text data.
        If e.Data.GetDataPresent(DataFormats.Text) Then
            ' Only allow the Copy operation.
            e.Effect = DragDropEffects.Copy Or DragDropEffects.Move
        End If
    End Sub

    ' Accept dropped data.
    Private Sub lblDrop_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lblDrop.DragDrop
        ' Get the dropped data.
        If e.Data.GetDataPresent(DataFormats.Text) Then
            lblDrop.Text = e.Data.GetData(DataFormats.Text).ToString()

            ' See if the Ctrl key is pressed.
            If (e.KeyState And KeyCtrl) <> 0 Then
                ' The Ctrl key is pressed. We did a Copy.
                e.Effect = DragDropEffects.Copy
            Else
                ' The Ctrl key is not pressed. We did a Move.
                e.Effect = DragDropEffects.Move
            End If
        End If
    End Sub

    ' Provide feedback. Allow Copy if Ctrl is pressed.
    ' Otherwise allow Move.
    Private Sub lblDrop_DragOver(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lblDrop.DragOver
        ' See if the Ctrl key is pressed.
        If (e.KeyState And KeyCtrl) <> 0 Then
            ' The Ctrl key is pressed. Allow Copy.
            e.Effect = DragDropEffects.Copy
        Else
            ' The Ctrl key is not pressed. Allow Move.
            e.Effect = DragDropEffects.Move
        End If
    End Sub
End Class
